# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------
# pylint: disable=line-too-long
# pylint: disable=too-many-lines

from knack.help_files import helps


helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration'] = """
    type: group
    short-summary: identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-aut\
h-configuration
"""

helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration update'] = """
    type: command
    short-summary: Update entity in certificateBasedAuthConfiguration
    parameters:
      - name: --certificate-authorities
        short-summary: Collection of certificate authorities which creates a trusted certificate chain.
        long-summary: |
            Usage: --certificate-authorities is-root-authority=XX certificate-revocation-list-url=XX \
delta-certificate-revocation-list-url=XX certificate=XX issuer=XX issuer-ski=XX

            is-root-authority: Required. true if the trusted certificate is a root authority, false if the trusted \
certificate is an intermediate authority.
            certificate-revocation-list-url: The URL of the certificate revocation list.
            delta-certificate-revocation-list-url: The URL contains the list of all revoked certificates since the \
last time a full certificate revocaton list was created.
            certificate: Required. The base64 encoded string representing the public certificate.
            issuer: The issuer of the certificate, calculated from the certificate value. Read-only.
            issuer-ski: The subject key identifier of the certificate, calculated from the certificate value. \
Read-only.

            Multiple actions can be specified by using more than one --certificate-authorities argument.
"""

helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration delete'] = """
    type: command
    short-summary: Delete entity from certificateBasedAuthConfiguration
"""

helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration create-certificate-based-auth-configuration'] = """
    type: command
    short-summary: Add new entity to certificateBasedAuthConfiguration
    parameters:
      - name: --certificate-authorities
        short-summary: Collection of certificate authorities which creates a trusted certificate chain.
        long-summary: |
            Usage: --certificate-authorities is-root-authority=XX certificate-revocation-list-url=XX \
delta-certificate-revocation-list-url=XX certificate=XX issuer=XX issuer-ski=XX

            is-root-authority: Required. true if the trusted certificate is a root authority, false if the trusted \
certificate is an intermediate authority.
            certificate-revocation-list-url: The URL of the certificate revocation list.
            delta-certificate-revocation-list-url: The URL contains the list of all revoked certificates since the \
last time a full certificate revocaton list was created.
            certificate: Required. The base64 encoded string representing the public certificate.
            issuer: The issuer of the certificate, calculated from the certificate value. Read-only.
            issuer-ski: The subject key identifier of the certificate, calculated from the certificate value. \
Read-only.

            Multiple actions can be specified by using more than one --certificate-authorities argument.
"""

helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration get-certificate-based-auth-configuration'] = """
    type: command
    short-summary: Get entity from certificateBasedAuthConfiguration by key
"""

helps['identitycertificatebasedauthconfiguration certificate-based-auth-configuration-certificate-based-auth-configuration list-certificate-based-auth-configuration'] = """
    type: command
    short-summary: Get entities from certificateBasedAuthConfiguration
"""
