# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------
# pylint: disable=protected-access

import argparse
from knack.util import CLIError
from collections import defaultdict


class AddCertificateAuthorities(argparse._AppendAction):
    def __call__(self, parser, namespace, values, option_string=None):
        action = self.get_action(values, option_string)
        super(AddCertificateAuthorities, self).__call__(parser, namespace, action, option_string)

    def get_action(self, values, option_string):  # pylint: disable=no-self-use
        try:
            properties = defaultdict(list)
            for (k, v) in (x.split('=', 1) for x in values):
                properties[k].append(v)
            properties = dict(properties)
        except ValueError:
            raise CLIError('usage error: {} [KEY=VALUE ...]'.format(option_string))
        d = {}
        for k in properties:
            kl = k.lower()
            v = properties[k]
            if kl == 'is-root-authority':
                d['is_root_authority'] = v[0]
            elif kl == 'certificate-revocation-list-url':
                d['certificate_revocation_list_url'] = v[0]
            elif kl == 'delta-certificate-revocation-list-url':
                d['delta_certificate_revocation_list_url'] = v[0]
            elif kl == 'certificate':
                d['certificate'] = v[0]
            elif kl == 'issuer':
                d['issuer'] = v[0]
            elif kl == 'issuer-ski':
                d['issuer_ski'] = v[0]
        return d
